import express from 'express';

// Route imports
import skuRoute from './:id.js';
import testRoute from './test.js';
import dashboardRoute from './dashboard.js';
import itemsRoute from './items.js';
import manage_routes from "./manage/index.js";

// Router base is '/'
const Router = express.Router({ strict: false });

Router.use('/test', testRoute);
Router.use('/items', itemsRoute)
Router.use('/:id(\\w{8})', skuRoute);
Router.use('/manage', manage_routes);
Router.use('/', dashboardRoute);

export default Router;
